//Jamie Morken July 18/2002	Rocket Research


#include <io.h>
#include <interrupt.h>
#include <signal.h>
#include <progmem.h>
#include "uart.h"

 
int main(void)
{

u08 data;

UART_Init();

sbi(DDRD, PD6);		//set mosfet channel 1 (TP1 on board) to output
sbi(DDRD, PD7);		//set mosfet channel 2 (TP2 on board) to output 
sbi(DDRB, PB2);		//set mosfet channel 3 (TP3 on board) to output 
sbi(DDRB, PB1);		//set mosfet channel 4 (TP4 on board) to output

//cbi(PORTD, PD6);	//initialize all mosfet control lines to 0 (off)
//cbi(PORTD, PD7);	
//cbi(PORTB, PB2);	
//cbi(PORTB, PB1);	
         
PRINT("mosfet channel tester V 0.1\r\n");

while(1)
{
if (UART_CharAvail())
 {
 data = UART_ReceiveByte();
 switch (data)
  {

  case '1':
  	   {
		if (bit_is_set(PORTD, PD6))	//toggle the channel on or off
			{	
			cbi(PORTD, PD6);
			PRINT("mosfet 1 low");
			EOL();
			PRINT("\n\n");
			}
		else
			{
			sbi(PORTD, PD6);
			PRINT("mosfet 1 high");
			EOL();
			PRINT("\n\n");
			}
	   }
	   break;

  case '2':
  	   {
		if (bit_is_set(PORTD, PD7))	//toggle the channel on or off
			{	
			cbi(PORTD, PD7);
			PRINT("mosfet 2 low");
			EOL();
			PRINT("\n\n");
			}
		else
			{
			sbi(PORTD, PD7);
			PRINT("mosfet 2 high");
			EOL();
			PRINT("\n\n");
			}
	   }
	   break;

  case '3':
  	   {
		if (bit_is_set(PORTB, PB2))	//toggle the channel on or off
			{	
			cbi(PORTB, PB2);
			PRINT("mosfet 3 low");
			EOL();
			PRINT("\n\n");
			}
		else
			{
			sbi(PORTB, PB2);
			PRINT("mosfet 3 high");
			EOL();
			PRINT("\n\n");
			}
	   }
	   break;

  case '4':
  	   {
		if (bit_is_set(PORTB, PB1))	//toggle the channel on or off
			{	
			cbi(PORTB, PB1);
			PRINT("mosfet 4 low");
			EOL();
			PRINT("\n\n");
			}
		else
			{
			sbi(PORTB, PB1);
			PRINT("mosfet 4 high");
			EOL();
			PRINT("\n\n");
			}
	   }
	   break;

  case 'q': 
  	   { 		   
		cbi(PORTD, PD6);	//turn all mosfet control lines off
		cbi(PORTD, PD7);	
		cbi(PORTB, PB2);	
		cbi(PORTB, PB1);	
		PRINT("all mosfet control lines turned off");
		EOL();
		PRINT("\n\n"); 
	   } 
	   break; 

  case 's': 
  	   { 	   
		sbi(PORTD, PD6);	//turn all mosfet control lines on
		sbi(PORTD, PD7);	
		sbi(PORTB, PB2);	
		sbi(PORTB, PB1);	
		PRINT("all mosfet control lines turned on");
		EOL();
		PRINT("\n\n"); 
	   } 
	   break; 

  case '?':
  default:
  	  
	  PRINT("\n\n1....toggle mosfet channel 1\r\n");
  	  PRINT("\n\n2....toggle mosfet channel 2\r\n");   
	  PRINT("\n\n3....toggle mosfet channel 3\r\n");   
  	  PRINT("\n\n4....toggle mosfet channel 4\r\n");   
	  PRINT("\n\nq....turn all mosfet channels off\r\n");
	  PRINT("\n\ns....turn all mosfet channels on\r\n");
  	  PRINT("\n\n?....Print Help\r\n\n\n");

  break;
  }//Case
 }//If

}	//end of while(1)

}	//end of main


