//created 20021013
//simple executive/task scheduler
//optionally use a watchdog in each task to make sure we dont get stuck in a task
//email jmorken@shaw.ca for help/info

#include <interrupt.h>	//include the relevant code for interrupts for your microcontroller
#include <signal.h>

	
//timeout values for each task
// ie1. if overflow is called 1000 times per second, then a value of 8000 for t1 will call the task once every 8 seconds (8000/1000 = 8 seconds)	
// ie2. if overflow is called 3600 times per second, then a value of 1 for t1 will call the task once every 0.000277 seconds (1/3600 = 0.000277 seconds)	
#define t1 1
#define t2 360	
#define t3 1	
#define t4 900		
#define t5 21600

int time1, time2, time3, time4, time5;	//task scheduling timeout counters

void task1(void);
void task2(void);
void task3(void);
void task4(void);
void task5(void);
  

SIGNAL(SIG_OVERFLOW0)	//example of a timer overflow
{  

	// Decrement the task timers if they are not already zero
	if (time1>0)	--time1;
	if (time2>0)	--time2;
	if (time4>0)	--time4;
	if (time5>0)	--time5;

}


void initialize(void)
{
  
	//initialize task timers
	time1=t1;
	time2=t2;
	time3=t3;
	time4=t4;
	time5=t5;

	//set up your timer here (simple task scheduler) 
	//use one of the microcontrollers timer/counters to overflow somewhere around 1000 to 10000 times per second 
	//thus will go to overflow ISR 1000 to 10000 times/second etc..

}

int main(void)
{				

	initialize();

	while (1)
	{
	    if (time1==0)	task1();	//if it is time to call the task, call it
	    if (time2==0)	task2();
	    if (time3==0)	task3();
	    if (time4==0)	task4();
		if (time5==0)	task5();
	}

}	//end of main



void task1(void)
{

	time1=t1;  				// reset the task timer
 
	//put task specific code here
}


void task2(void)
{       

	time2=t2;

}


void task3(void)
{

	time3 = t3;
 

} 


void task4(void)
{

	time4 = t4;		



}


void task5(void)
{

	time5 = t5;		


}